%% data structure to keep images
R = [];
G = [];
B = [];
%% the sample images should be read 1-by-1
im = imread('table3.png');
fprintf('done \t');


%% the part containing the object should be selected
[sub] = imcrop(im(:,:,1:3));
imshow(sub);
subR = double(sub(:,:,1));
subG = double(sub(:,:,2));
subB = double(sub(:,:,3));



R = [R subR(:)'];
G = [G subG(:)'];
B = [B subB(:)'];

%save
%load matlab

%% After taking all samples, the histogram drawn automatically

R = R / 16;
G = G / 16;
B = B / 16;

    subplot(1,3,1);
hist(double(R),16)
title('R');
hold on;
    subplot(1,3,2);
hist(double(G),16)
title('G');
hold on;
    subplot(1,3,3);
hist(double(B),16)
title('B');
hold on;

%% bound finding & the mask and the object shown to see the result of 
%%the color coding

im = imread('table3.png');

%the bounds for each color channel
%the values that should be pass the microprocessor for color coding
bR = prctile(R,[25-12.5 75+12.5])
bG = prctile(G,[10 90])
bB = prctile(B,[25 75])

maskR(:,:) = im(:,:,1)/16 > floor(bR(1)) & im(:,:,1)/16 < ceil(bR(2));

maskG(:,:) = im(:,:,2)/16 > floor(bG(1)) & im(:,:,2)/16 < ceil(bG(2));

maskB(:,:) = im(:,:,3)/16 > floor(bB(1)) & im(:,:,3)/16 < ceil(bB(2));

mask =maskB & maskR & maskG;


    subplot(1,3,1);
    hold on
    title('mask R');
    hold on
    imshow(maskR);
    subplot(1,3,2);
    hold on
    title('mask G');
    imshow(maskG);
    subplot(1,3,3);
    hold on
    title('mask B');
    imshow(maskB);
    figure;
    subplot(1,2,1);
    hold on
    title('mask RGB');
    imshow(mask);
    subplot(1,2,2);
    hold on
    title('orginal picture');
    imshow(im);
    

